Codeforces Round #305 (Div. 2) E. Mike and Foam 容斥原理

在一个集合中,找和x互素的数有多少?

用容斥定理,先把每个数质因数分解(每个数至多有6个质因子),奇减偶加,就统计到和x互素的数了。

代码:

#include<iostream>
#include<vector>
#include<algorithm>
#include<cstdio>
#include<cstring>
using namespace std;
const int N = 5*100000+10;
const int maxn = 5*100000;

int cnt[N],pri[N],vis[N],num;
vector<int> gc[N];

void init(){
    memset(cnt,0,sizeof(cnt));
    for(int i=0;i<=maxn;i++)
        gc[i].clear();

    for(int i=2;i<=maxn;i++) if(gc[i].size()==0)
        for(int j=i;j<=maxn;j+=i)
            gc[j].push_back(i);
}

void add(int x,int y){
    int size = gc[x].size();
    for(int i=0;i<(1<<size);i++){
        int tmp=1;
        for(int j=0;j<size;j++)
        if(i&(1<<j)){
            tmp *= gc[x][j];
        }
        cnt[tmp] += y;
    }
}

int cal(int x){
    int ans = 0;
    int size = gc[x].size();
    for(int i=0;i<(1<<size);i++){
        int tmp = 1, fl = 1;
        for(int j=0;j<size;j++)
        if(i&(1<<j)){
            tmp *= gc[x][j];
            fl *= -1;
        }
        ans += fl*cnt[tmp];
    }
//    printf("hehe  %d\n",ans);
    return ans;
}

int a[N],fl[N];
int main(){
    int n,q,x;
    cin >> n >> q;
    init();
    memset(fl,0,sizeof(fl));
    long long ans = 0;
    for(int i=1;i<=n;i++) scanf("%d",&a[i]);
    for(int i=1;i<=q;i++){
        scanf("%d",&x);
        if(!fl[x]){
            ans += cal(a[x]);
            add(a[x],1);
            fl[x] = 1;
        }
        else{
            add(a[x],-1);
            ans -= cal(a[x]);
            fl[x] = 0;
        }
        printf("%I64d\n",ans);
    }
    return 0;
}
时间: 2024-10-05 07:52:35

Codeforces Round #305 (Div. 2) E. Mike and Foam 容斥原理的相关文章

Codeforces Round #305 (Div. 1)C. Mike and Foam(素数+容斥)

题目链接:点这里!!! 题意: 输入n(n<=2e5),q(q<=2e5).紧接着输入n个数a1~an(ai<=5e5).给定一个空集合. 针对每个q,输入x,如果a[x]在不在集合里面,将a[x]插入进去,并且求当前该集合中有多少对互质的数: 如果a[x]在集合里面,将a[x]删除,并且求当前该集合有多少对互质的数. 题解: 1. 将所有数的素因子求出来.(最多6个) 2.如果将a[x]插入进去,我们检查由a[x]的素因子能组成的数有哪些,全部+1. 比如a[x]=12,我们将2.3.

暴力 Codeforces Round #305 (Div. 2) B. Mike and Fun

题目传送门 1 /* 2 暴力:每次更新该行的num[],然后暴力找出最优解就可以了:) 3 */ 4 #include <cstdio> 5 #include <cstring> 6 #include <iostream> 7 #include <algorithm> 8 #include <string> 9 using namespace std; 10 11 const int MAXN = 5e2 + 10; 12 const int

set+线段树 Codeforces Round #305 (Div. 2) D. Mike and Feet

题目传送门 1 /* 2 题意:对于长度为x的子序列,每个序列存放为最小值,输出长度为x的子序列的最大值 3 set+线段树:线段树每个结点存放长度为rt的最大值,更新:先升序排序,逐个添加到set中 4 查找左右相邻的位置,更新长度为r - l - 1的最大值,感觉线段树结构体封装不错! 5 详细解释:http://blog.csdn.net/u010660276/article/details/46045777 6 其实还有其他解法,先掌握这种:) 7 */ 8 #include <cstd

数论/暴力 Codeforces Round #305 (Div. 2) C. Mike and Frog

题目传送门 1 /* 2 数论/暴力:找出第一次到a1,a2的次数,再找到完整周期p1,p2,然后以2*m为范围 3 t1,t2为各自起点开始“赛跑”,谁落后谁加一个周期,等到t1 == t2结束 4 详细解释:http://blog.csdn.net/u014357885/article/details/46044287 5 */ 6 #include <cstdio> 7 #include <algorithm> 8 #include <cstring> 9 #in

字符串处理 Codeforces Round #305 (Div. 2) A. Mike and Fax

题目传送门 1 /* 2 字符串处理:回文串是串联的,一个一个判断 3 */ 4 #include <cstdio> 5 #include <cstring> 6 #include <iostream> 7 #include <algorithm> 8 #include <string> 9 using namespace std; 10 11 const int MAXN = 1e3 + 10; 12 const int INF = 0x3f3

Codeforces Round #305 (Div. 1) B. Mike and Feet

Mike is the president of country What-The-Fatherland. There are n bears living in this country besides Mike. All of them are standing in a line and they are numbered from 1 to n from left to right. i-th bear is exactly ai feet high. A group of bears

Codeforces Round #305 (Div. 2) C. Mike and Frog +B. Mike and Fun

Mike has a frog and a flower. His frog is named Xaniar and his flower is named Abol. Initially(at time 0), height of Xaniar is h1 and height of Abol is h2. Each second, Mike waters Abol and Xaniar. So, if height of Xaniar is h1 and height of Abol is 

Codeforces Round #305 (Div. 1) B. Mike and Feet(并查集)

题目链接:点击打开链接 思路:我们把元素从大到小排序, 从大到小依次合并区间, 对于第i个数, 如果他相邻左边的数比他大就合并, 相邻右边也一样.这样, 我们就求出了第i个数为最小值的最大区间. 更新答案即可. 细节参见代码: #include <cstdio> #include <cstring> #include <algorithm> #include <iostream> #include <string> #include <ve

Codeforces Round #305 (Div. 1)

547A - Mike and Frog Solution:  先求出两种变化的第一次和第二次变化到目标的时间. 对这四个时间的具体情况需要一些特判 . 然后直接从1到2*N枚举其中一个时间的倍数,然后输出第一个满足要求的答案.  或者求出循环节后用拓展欧几里得求出最小解. 547B - Mike and Feet 题意: 给定一个长度为n(<=2*10^5)的序列,分别求出长度为(1~n)的区间的最小数的最大值. Solution: 可以先预处理以每个数为答案的最长区间. 即从每个数分别从左和